# The LearningOnline Network with CAPA
# input  definitons

package Apache::inputtags;
use strict;

sub BEGIN {
  &Apache::lonxml::register('Apache::inputtags',('textarea','textline','datasubmission'));
}


sub initialize_inputtags {
  @Apache::inputtags::input=();
  @Apache::inputtags::response=();
  @Apache::inputtags::responselist=();
  @Apache::inputtags::answergroup=();
  $Apache::inputtags::part='';
  %Apache::inputtags::params=();
}

sub start_textarea {
  my ($target,$token,$parstack,$parser,$safeeval)=@_;
  my $result = "";
  if ($target eq 'web') {
    $result= '<textarea name="HWVAL'.$Apache::inputtags::curvalue.'" value="">';
  }
  return $result;
}

sub end_textarea {
  my ($target,$token,$parstack,$parser,$safeeval)=@_;
  if ($target eq 'web') {
    return "</textarea>";
  } 
  return '';
}

sub start_textline {
  my ($target,$token,$parstack,$parser,$safeeval)=@_;
  my $result = "";
  if ($target eq 'web') {
    my $args ='';
    if ( $#$parstack > -1 ) { $args=$$parstack[$#$parstack]; }
    my $size = &Apache::run::run("{$args;".'return $size}',$safeeval);
    if ($size eq '') { $size=20; }
    $result= '<input type="text" name="HWVAL'.$Apache::inputtags::curvalue.'" value="" size="'.$size.'">';
  }
  return $result;
}

sub end_textline {
  my ($target,$token,$parstack,$parser,$safeeval)=@_;
  return "";
}

#answergroup is deprecated
#sub start_answergroup {
#  my ($target,$token,$parstack,$parser,$safeeval)=@_;
#  my $args ='';
#  if ( $#$parstack > -1 ) { $args=$$parstack[$#$parstack]; }
#  my $id = &Apache::run::run("{$args;".'return $id}',$safeeval);
#  push (@Apache::inputtags::answergroup,$id);
#  if ($target == 'web') {
#    
#  }
#  return '';
#}
#
#sub end_answergroup {
#  my ($target,$token,$parstack,$parser,$safeeval)=@_;
#  return ''; # <answergroup> has ben deprecated
#  my $args ='';
#  if ( $#$parstack > -1 ) { $args=$$parstack[$#$parstack]; }
#  my $id = &Apache::run::run("{$args;".'return $id}',$safeeval);
#  push (@Apache::inputtags::answergroup,$id);
#  my $result='';
#  my $button='<input type="submit" name="submit" value="Submit All Answers">';
#  my $showbutton='1';
#  my $usedtry='1';
#  my $response='';
#  if ( $target == 'web' ) {
#    if ( defined $ENV{'form.submit'}) {
#    }
#    if ($showbutton > 0) { $result.=$button }
#  }
#  pop @Apache::inputtags::answergroup;
#  return $result;
#}


sub start_datasubmission {
}

sub end_datasubmission {
  my ($target,$token,$parstack,$parser,$safeeval)=@_;
  if ( $target == 'web' ) {
    return '<input type="submit" name="submit" value="Submit All Data">';
  }
  return '';
}

sub finalizeawards {
  my $result='';
  my $award;
  if ($#_ == '-1') { $result = "NO_RESPONSE"; }
  foreach $award (@_) { if ($award eq '') {$result='MISSING_ANSWER'; last;}}
  if ($result eq '' ) {
    foreach $award (@_) { 
      if ($award eq 'UNIT_FAIL' ||
	  $award eq 'NO_UNIT' ||
	  $award eq 'UNIT_NOTNEEDED') {
	$result=$award; last;
      }
    }
  }
  if ($result eq '' ) {
    foreach $award (@_) { 
      if ($award eq 'WANTED_NUMERIC' || 
	  $award eq 'BAD_FORMULA') {$result=$award; last;}
    }
  }
  if ($result eq '' ) {
    foreach $award (@_) { if ($award eq 'SIG_FAIL') {$result=$award; last;} }
  }
  if ($result eq '' ) {
    foreach $award (@_) { if ($award eq 'INCORRECT') {$result=$award; last;} }
  }
  if ($result eq '' ) {
    foreach $award (@_) { if ($award eq 'APPROX_ANS') {$result=$award; last;} }
  }
  if ($result eq '' ) { $result='EXACT_ANS'; }
  return $result
}

sub decideoutput {
  my ($award)=@_;
  my $message='';
  my $button=0;
  if      ($award eq 'EXACT_ANS' || $award eq 'APPROX_ANS' ) {
    $message = "Correct computer gets %s";
    $button=0;
  } elsif ($award eq 'NO_RESPONSE') {
    $message = '';
    $button=1;
  } elsif ($award eq 'WANTED_NUMERIC') {
    $message = "This question expects a numeric answer";
    $button=1;
  } elsif ($award eq 'SIG_FAIL') {
    $message = "Please adjust significant figures, you provided %s significant figures";
    $button=1;
  } elsif ($award eq 'UNIT_FAIL') {
    $message = "Units incorrect, Computer reads units as %s";
    $button=1;
  } elsif ($award eq 'UNIT_NOTNEEDED') {
    $message = "Only a number required, Computer reads units of %s";
    $button=1;
  } elsif ($award eq 'NO_UNIT') {
    $message = "Units required";
    $button=1;
  } elsif ($award eq 'BAD_FORMULA') {
    $message = "Unable to understand formula";
    $button=1;
  } elsif ($award eq 'INCORRECT') {
    $message = "Incorrect";
    $button=1;
  } else {
    $message = "Unknown message: $award";
    $button=1;
  }
  return ($button,$message);
}

sub setgradedata {
  my ($award,$id) = @_;
  if ( $award eq 'APPROX_ANS' || $award eq 'EXACT_ANS' ) {
    $Apache::lonhomework::results{"resource.tries.$id"} =
      $Apache::lonhomework::history{"resource.tries.$id"} + 1;
    $Apache::lonhomework::results{"resource.solved.$id"} =
      'correct_by_student';
    $Apache::lonhomework::results{"resource.awarded.$id"} = '1';
  } elsif ( $award eq 'INCORRECT' ) {
    $Apache::lonhomework::results{"resource.tries.$id"} =
      $Apache::lonhomework::history{"resource.tries.$id"} + 1;
    $Apache::lonhomework::results{"resource.solved.$id"} =
      'incorrect_attempted';
  } else {
    $Apache::lonhomework::results{"resource.solved.$id"} =
      'incorrect_attempted';
  }
  $Apache::lonhomework::results{"resource.award.$id"} = $award;
}

sub grade {
  my ($target) = @_;
  my $id = $Apache::inputtags::part;
  my $result='';
  my $response='';
  if ( $target == 'web' ) {
    if ( defined $ENV{'form.submit'}) {
      my @awards = ();
      &Apache::lonxml::debug("$#Apache::inputtags::responselist");
      foreach $response (@Apache::inputtags::responselist) {
	&Apache::lonxml::debug("looking for response.awarddetail.$id.$response");
	my $value=$Apache::lonhomework::results{"resource.awarddetail.$id.$response"};
	if ( $value ne '' ) {
	  &Apache::lonxml::debug("keep ing $value from $response for $id");
	  push (@awards,$value);
	} else {
	  &Apache::lonxml::debug("skipping $value from $response for $id");
	}
      }
      my $finalaward = &finalizeawards(@awards);
      &Apache::lonxml::debug("final award $finalaward");
      &setgradedata($finalaward,$id);
    }
  }
  return $result;
}

sub gradestatus {
  my ($id) = @_;
  my $showbutton = 1;
  my $message = '';
  my $award = $Apache::lonhomework::history{"resource.award.$id"};
  &Apache::lonxml::debug("Found Award |$award|");
  if ( $award ne '' ) {
    &Apache::lonxml::debug('Getting message');
    ($showbutton,$message) = &decideoutput($award);
  }
  my $button='';
  my $tries = $Apache::lonhomework::history{"resource.tries.$id"};
  my $maxtries = $Apache::lonhomework::history{"resource.maxtries.$id"};
  if ( $tries eq '' ) { $tries = '0'; }
  if ( $maxtries eq '' ) { $maxtries = '2'; } 
  my $trystr='';
  if ( $showbutton ) {
    $trystr = "<br></br>Tries $tries/$maxtries";
  }
  if ( $tries >= $maxtries ) { $showbutton = 0; }
  if ( $showbutton ) { 
    $button = '<input type="submit" name="submit" value="Submit All Answers"><br></br>';
  }
  return $button.$message.$trystr;
}
1;
__END__
 
