# The LON-CAPA Homework handler
# Guy Albertelli
# 11/30 Gerd Kortemeyer

package Apache::lonhomework;
use strict;
use Apache::style;
use Apache::lonxml;
use Apache::lonnet;
use Apache::inputtags;
use Apache::structuretags;
use Apache::response;


sub get_target {
  if ( $ENV{'request.state'} eq "published") {
    if ( defined $ENV{'form.submit'}) {
      return ('grade', 'web');
    } else {
      return ('web');
    }
  } elsif ($ENV{'request.state'} eq "construct") {
    if ( defined $ENV{'form.preview'}) {
      if ( defined $ENV{'form.submit'}) {
	return ('grade', 'web');
      } else {
	return ('web');
      }
    } else {
      return ('edit');
    }
  }
  return ();
}

sub setup_vars {
  my ($target) = @_;
  return ';'
#  return ';$external::target='.$target.';';
}

sub send_header {
  my ($request)= @_;
  $request->print(&Apache::lontexconvert::header());
  $ENV{'request.uri'}=$request->uri;
#  $request->print('<form name='.$ENV{'form.request.prefix'}.'lonhomework method="POST" action="'.$request->uri.'">');
}

sub send_footer {
  my ($request)= @_;
#  $request->print('</form>');
  $request->print(&Apache::lontexconvert::footer());
}

sub handler {
  my $request=$_[0];

#  if ( $ENV{'user.name'} eq 'albertel' ) { $Apache::lonxml::debug=1; }
  
  my (@targets) = &get_target();

  if ($ENV{'browser.mathml'}) {
    $request->content_type('text/xml');
  } else {
    $request->content_type('text/html');
  }
  $request->send_http_header;
  return 'OK' if $request->header_only;
  
  &Apache::lonhomework::send_header($request);
  
  foreach my $target (@targets) {
    my $file=&Apache::lonnet::filelocation("",$request->uri);
    my $problem=&Apache::lonnet::getfile($file);
    if ($problem == -1) {
      &Apache::lonxml::error("<b> Unable to find <i>$file</i></b>");
      $problem='';
    }
    
    my %mystyle;
    my $result = '';
    &Apache::inputtags::initialize_inputtags;
    %Apache::lonhomework::results=();
    %Apache::lonhomework::history=&Apache::lonnet::restore;
    #ignore error conditions
    my ($temp)=keys %Apache::lonhomework::history ;
    if ($temp =~ m/^error:.*/) { %Apache::lonhomework::history=(); } 
    
    if ($target eq 'grade') {
      my $resultkey;
      foreach $resultkey (sort keys %Apache::lonhomework::history) {
	&Apache::lonxml::debug("$resultkey ---- $Apache::lonhomework::history{$resultkey}");
      }
      &Apache::lonxml::debug("\n<br>restored values^</br>\n");
    }
    my $default=&Apache::lonnet::getfile('/home/httpd/html/res/adm/includes/default_homework.lcpm');
    if ($default == -1) {
      &Apache::lonxml::error("<b>Unable to find <i>default_homework.lcpm</i></b>");
      $default='';
    }
    if ( $target eq 'grade') { 
      $Apache::lonxml::textredirection = 0; 
    } else {
      $Apache::lonxml::textredirection = 1; 
    }
    $result = &Apache::lonxml::xmlparse($target, $problem,
			$default.&setup_vars($target),%mystyle);

    #$request->print("Result follows:");
    $request->print($result);
    #$request->print(":Result ends");
    if ($target eq 'grade') {
      my $resultkey;
      foreach $resultkey (sort keys %Apache::lonhomework::results) {
	&Apache::lonxml::debug("$resultkey ---- $Apache::lonhomework::results{$resultkey}");
      }
      &Apache::lonxml::debug("\n<br>storing values^</br>\n");
    }
    
    my ($temp) = keys %Apache::lonhomework::results;
    if ( $temp ne '' ) {
      &Apache::lonxml::debug("Store return message:".&Apache::lonnet::cstore(%Apache::lonhomework::results));
    }
  }
  &Apache::lonhomework::send_footer($request);
  
  return 'OK';

}

1;
__END__
