# The LearningOnline Network with CAPA
# various response type definitons response definition

# 11/23,11/24,11/28 Gerd Kortemeyer

package Apache::response;
use strict;

sub BEGIN {
  &Apache::lonxml::register('Apache::response',('responseparam','caparesponse'));
}

sub meta_parameter_write {
    my ($name,$type,$default,$display)=@_;
    return '<parameter part="'.$Apache::inputtags::part.
	            '" name="'.$name.
                    '" type="'.$type.
                 '" default="'.$default.
	         '" display="'.$display.
                          ' [Part: '.$Apache::inputtags::part.']"></parameter>'
     ."\n";
}

sub meta_stores_write {
    my ($name,$type,$display)=@_;
    return '<stores part="'.$Apache::inputtags::part.
	         '" name="'.$name.
                 '" type="'.$type.
	      '" display="'.$display.
                       ' [Part: '.$Apache::inputtags::part.']"></stores>'
     ."\n";
}

sub mandatory_part_meta {
#
# Autogenerate metadata for mandatory
# input (from RAT or lonparmset) and 
# output (to lonspreadsheet)
# of each part
#
 return
    &meta_parameter_write('opendate','date_start','',
                          'Opening Date').
    &meta_parameter_write('duedate','date_end','',
                          'Due Date').
    &meta_parameter_write('answerdate','date_start','',
                          'Show Answer Date').
    &meta_parameter_write('weight','int_zeropos','',
                          'Available Points').
    &meta_parameter_write('maxtries','int_pos','',
                          'Maximum Number of Tries').

    &meta_stores_write('solved','string',
                          'Problem Status').
    &meta_stores_write('tries','int_zeropos',
                          'Number of Unsuccessful Tries').
    &meta_stores_write('awarded','float',
		          'Partial Credit Factor');
#
# Note: responseid-specific data 'submission' and 'awarddetail'
# not available to spreadsheet -> skip here
#
}

sub start_caparesponse {
  require Apache::caparesponse; 
  import Apache::caparesponse; 
  my ($target,$token,$parstack,$parser,$safeeval,$style)=@_;
#  print "\n<br>\nsimple caparesponse\n";
  Apache::caparesponse::start_caparesponse($target,$token,$parstack,$parser,$safeeval,$style);;
  return "";
}

sub start_responseparam {
  my ($target,$token,$parstack,$parser,$safeeval)=@_;
  if ($target eq 'grade') {
    my $args='';
    if ( $#$parstack > -1 ) { $args=$$parstack[$#$parstack]; }
    my $default = &Apache::run::run("{$args;".'return $default}',$safeeval);
    my $name = &Apache::run::run("{$args;".'return $name}',$safeeval);
    &Apache::lonxml::debug("looking for resource.$Apache::inputtags::part.$name");
    my $value = &Apache::lonnet::EXT("resource.$Apache::inputtags::part.$name");
    &Apache::lonxml::debug("$name has value :$value: and default :$default:");
    if ($value eq '') {
      &Apache::lonxml::debug("defaullting");
      $Apache::inputtags::params{$name}=$default;
    } else {
      &Apache::lonxml::debug("using value");
      $Apache::inputtags::params{$name}=$value;
    }
    return '';
  } elsif ($target eq 'meta') {
    return &meta_parameter_write($token->[2]->{'name'},
				 $token->[2]->{'type'},
				 $token->[2]->{'default'},
				 $token->[2]->{'description'});
  } else {
    return '';
  }
}

sub end_responseparam {
}

1;
__END__
 
