# The LearningOnline Network with CAPA # <script> definiton

package Apache::structuretags; 

use strict;
use Apache::lonnet;

sub BEGIN {
  &Apache::lonxml::register('Apache::structuretags',('block','while','randomlist','problem','web','tex','part'));
}

sub start_web {
  my ($target,$token,$parstack,$parser,$safeeval)=@_;
  my $bodytext=&Apache::lonxml::get_all_text("/web",$$parser[$#$parser]);
  if ($target eq 'web') {
    return $bodytext;
  } 
  return '';
}

sub end_web {
}

sub start_tex {
  my ($target,$token,$parstack,$parser,$safeeval)=@_;
  my $bodytext=&Apache::lonxml::get_all_text("/tex",$$parser[$#$parser]);
  if ($target eq 'tex') {
    return $bodytext
  }
  return '';
}

sub end_tex {
}

sub start_problem {
  my ($target,$token,$parstack,$parser,$safeeval)=@_;

#intialize globals
  $Apache::inputtags::part='0';
  @Apache::inputtags::responselist = ();

#adeed vars to the scripting enviroment
  my $expression='$external::part='.$Apache::inputtags::part.';';
  &Apache::run::run($expression,$safeeval);

  if ($target eq 'web') {
    # create a page header and exit
    my $args ='';
    if ( $#$parstack > -1 ) { $args=$$parstack[$#$parstack]; }
    my $name = &Apache::run::run("{$args;".'return $name}',$safeeval);
    return "<title>$name</title>\n<body bgcolor=#FFFFFF>\n<form name=\"lonhomework\" method=\"POST\" action=\"".$ENV{'request.uri'}."\">";
  } 
  return '';
}

sub end_problem {
  my ($target,$token,$parstack,$parser,$safeeval)=@_;
  my $result='';
  unless ($target eq 'meta') {
    if ( $target eq 'grade' && $Apache::inputtags::part eq '0') {
      # if part is zero, no <part>s existed, so we need to the grading
      &Apache::inputtags::grade;
    } elsif ($Apache::inputtags::part eq '0') {
      # if part is zero, no <part>s existed, so we need show the current 
      # grading status
      $result.= &Apache::inputtags::gradestatus($Apache::inputtags::part);
    } 
    if ($target eq 'web') { $result.="</form></body>\n"; }
  } else {
    if ($Apache::inputtags::part eq '0') {
      $result=&Apache::response::mandatory_part_meta;
    }
  }
  return $result;
}

sub start_block {
  my ($target,$token,$parstack,$parser,$safeeval)=@_;

  my $code = @$parstack[$#$parstack];
  $code =~ s/\"//g;
  $code .=';return $condition;';
#  print "<br>$code<br>";
  my $result = &Apache::run::run($code,$safeeval);
  if ( ! $result ) { 
#    my $skip=$$parser[$#$parser]->get_text("/block");
    my $skip=&Apache::lonxml::get_all_text("/block",$$parser[$#$parser]);
#    print "skipped $skip";
  }
  return "";
}

sub end_block {
}

sub start_while {
  my ($target,$token,$parstack,$parser,$safeeval)=@_;

  my $code = @$parstack[$#$parstack];
  $code =~ s/\"//g;
  $code .=';return $condition;';

  push( @Apache::structuretags::whileconds, $code); 
  my $result = &Apache::run::run($code,$safeeval);
  my $bodytext=$$parser[$#$parser]->get_text("/while");
  push( @Apache::structuretags::whilebody, $bodytext);
  if ( $result ) { 
    &Apache::lonxml::newparser($parser,\$bodytext);
  }
  return "";
}

sub end_while {
  my ($target,$token,$parstack,$parser,$safeeval)=@_;
  my $code = pop @Apache::structuretags::whileconds;
  my $bodytext = pop @Apache::structuretags::whilebody;
  my $result = &Apache::run::run($code,$safeeval);
  if ( $result ) { 
    &Apache::lonxml::newparser($parser,\$bodytext);
  } 
  return "";
}

# <randomlist> 
#  <tag1>..</tag1>
#  <tag2>..</tag2>
#  <tag3>..</tag3>
#  ... 
# </randomlist>
sub start_randomlist {
  my ($target,$token,$parstack,$parser,$safeeval)=@_;
  my $body= &Apache::lonxml::get_all_text("/randomlist",$$parser[$#$parser]);
  my $b_parser= HTML::TokeParser->new(\$body);
  my $b_tok;
  my @randomlist;
  my $list_item;

  while($b_tok = $b_parser->get_token() ) {
    if($b_tok->[0] eq 'S') { # start tag
    # get content of the tag until matching end tag
    # get all text upto the matching tag
    # and push the content into @randomlist
      $list_item = &Apache::lonxml::get_all_text('/'.$b_tok->[1],$b_parser);
      $list_item = "$b_tok->[4]"."$list_item"."</$b_tok->[1]>";
      push(@randomlist,$list_item);
   #  print "<BR><B>START-TAG $b_tok->[1], $b_tok->[4], $list_item</B>";
    }
    if($b_tok->[0] eq 'T') { # text
    # what to do with text in between tags?
      #  print "<B>TEXT $b_tok->[1]</B><BR>";
    }
    # if($b_tok->[0] eq 'E') { # end tag, should not happen
      #  print "<B>END-TAG $b_tok->[1]</B><BR>";
    # }
  }
  my @idx_arr = (0 .. $#randomlist);
  &Apache::structuretags::shuffle(\@idx_arr);
  my $bodytext = '';
  for(0 .. $#randomlist) {
    $bodytext .= "$randomlist[ $idx_arr[$_] ]";
  }

  &Apache::lonxml::newparser($parser,\$bodytext);
  return "";
}

sub shuffle {
    my $a=shift;
    my $i;
    for($i=@$a;--$i;) {
      my $j=int rand($i+1);
      next if $i == $j;
      @$a[$i,$j] = @$a[$j,$i];
    }
}

sub end_randomlist {
}

sub start_part {
  my ($target,$token,$parstack,$parser,$safeeval)=@_;
  my $args ='';
  if ( $#$parstack > -1 ) { $args=$$parstack[$#$parstack]; }
  my $id = &Apache::run::run("{$args;".'return $id}',$safeeval);
  $Apache::inputtags::part=$id;
  @Apache::inputtags::responselist = ();
  if ($target eq 'meta') {
    return &Apache::response::mandatory_part_meta;
  }
  return '';
}

sub end_part {
  my ($target,$token,$parstack,$parser,$safeeval)=@_;
  &Apache::lonxml::debug("in end_part $target ");
  if ( $target eq 'meta' ) { return ''; }
  if ( $target eq 'grade' ) { return &Apaceh::inputtags::grade; }
  return &Apache::inputtags::gradestatus($Apache::inputtags::part);
}

1;
__END__
